# all files / lighthouse-core/audits/ manifest-icons-min-192.js

100% Statements 10/10
100% Branches 4/4
100% Functions 2/2
100% Lines 10/10

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62

    1×
    1×

    23×

    7×

    7×
    2×

    5×

    5×

    5×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All rights reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    'use strict';

    const Audit = require('./audit');
    const icons = require('../lib/icons');

    class ManifestIconsMin192 extends Audit {
      /**
       * @return {!AuditMeta}
       */
      static get meta() {
        return {
          category: 'Manifest',
          name: 'manifest-icons-min-192',
          description: 'Manifest contains icons at least 192px',
          requiredArtifacts: ['Manifest']
        };
      }

      /**
       * @param {!Artifacts} artifacts
       * @return {!AuditResult}
       */
      static audit(artifacts) {
        const manifest = artifacts.Manifest.value;

        if (icons.doExist(manifest) === false) {
          return ManifestIconsMin192.generateAuditResult({
            value: false,
            debugString: 'WARNING: No icons found in the manifest'
          });
        }

        const matchingIcons = icons.sizeAtLeast(192, /** @type {!Manifest} */ (manifest));

        const foundSizesDebug = matchingIcons.length ?
            `Found icons of sizes: ${matchingIcons}` : undefined;
        return ManifestIconsMin192.generateAuditResult({
          value: !!matchingIcons.length,
          debugString: foundSizesDebug
        });
      }
    }

    module.exports = ManifestIconsMin192;